@startuml 

skinparam handwritten true
skinparam activity {
    BackgroundColor #F7F7F7
    BorderColor #0092BC
    ArrowColor #E53138
}

start
-[#green]->
:**POST** ""/uid/**[ref]**/msg?author=**[author]**&content=**[message]**"" ]
-[#green]->
if (**[author]** exists ?) then (yes)
    -[#green]->
else (no)
    :HTTP 400 (1) ]
    detach
endif

-[#green]->
if (**[message]** exists ?) then (yes)
    -[#green]->
else (no)
    :HTTP 400 (2) ]
    detach
endif

-[#green]->
if (**[ref]** exists ?) then (yes)
    -[#green]->
else (no)
    :create new **[UID]** ]
    :create **[ref]** ]
    :link **[ref]** to **[UID]** ]
endif

-[#green]->
:create new message linked to **[ref]** and **[author]** ]

-[#green]->
:HTTP 200 (3) ]

legend
__HTTP Responses__ :
(1) "Missing author"
(2) "Missing content"
(3) "Message created and linked to this reference"
    or "Message created and linked to this reference, which didn't exist and was created on the fly"
endlegend

@enduml
